#!/usr/bin/env python
#
#  Copyright (c) 2014 Dell, Inc.
#  by Praveen K Paladugu <praveen_paladugu@dell.com>
#  Licensed under the GNU General Public license, version 2 or higher.
#

import sys
import logging
import subprocess
#import App_Conf_Parser
import DialogBox
import gettext
import PAM

gettext.textdomain('dell_app_init')
_ = lambda x: gettext.ldgettext("dell_app_init", x)

## X server should be up by now. So, the following import should be fine
try:
    import gtk
    import gtk.glade
except:
    print "Gtk/Glade is not installed."
    sys.exit(1)

gtk.glade.bindtextdomain('dell_app_init','/usr/share/locale')
gtk.glade.textdomain('dell_app_init')



class  Auth_Win:

    _auth_passed = 0
    _passwd = ""
    @staticmethod
    def verify_password(user, password):


	def pam_conv(auth, query_list):
	#    print "Inside pam_conv"
	    resp = []
	    resp.append( (password, 0))
	    return resp

	res = -3
	
	#print "user: passowrd=",user,password
	service = 'passwd'
	auth = PAM.pam()
	auth.start(service)
	auth.set_item(PAM.PAM_USER, user)
	auth.set_item(PAM.PAM_CONV, pam_conv)
	auth.set_userdata("testing user data")
	try:
	    auth.authenticate()
	    auth.acct_mgmt()
	except PAM.error, (resp, code):
	   # print 'Go away! (%s)' % resp
	    res = -1
	except:
	    #print 'Internal error'
	    res = -2
	else:
	    #print 'Good to go!'
	    res = 0

	return res

    def get_passwd(self):
	"""Return the password from the Text Entry"""
	return self._passwd


    def on_AuthButton_clicked(self, widget):
	"""Check the password now. """
	self._passwd = self.authEntry.get_text()
	self.auth_window.hide_all()
	
	ret = Auth_Win.verify_password(self._user,self._passwd)

	if ret == -1:
	    ## Authentication Failed
	    msg = "Entered password is incorrect, please try again."
	    db = DialogBox.DialogBox(self.auth_window,msg,buttons=gtk.BUTTONS_OK)
            rc = db.display()

	    self._auth_passed = 0
	    self.auth_window.show_all()

	elif ret == 0:
	    self._auth_passed = 1
	    gtk.main_quit()

	return
	
    def on_Cancel_clicked (self,widget):
	""" Exit upon Cancel button clicked"""
	self._auth_passed = 0
	self.auth_window.hide_all()
	gtk.main_quit()
	return
	
    def auth_passed (self):
	""" Return True if authentication passed successfuly"""
	if self._auth_passed == 1:
	    return True
	else:
	    return False	


    def __init__(self, parser=None, user=None):

	self._auth_passed = 0 
	if not parser == None:
	    self.parser = parser	

	if not user == None:
	    self._user = user
	else:
	    self._user = "root"
    
	self.logger = logging.getLogger("startup_app.Authentication ")
        auth_glade_path =  "/usr/share/dell_app_init/Authentication.glade"

        self.logger.debug (_("Glade file of Authentication window = %s"), auth_glade_path )

	#load the Glade file
    	auth_tree_xml = gtk.glade.XML(auth_glade_path,"AuthWindow")
    
	#Connect the signal handlers
	auth_tree_xml.signal_autoconnect(self)
	self.auth_window = auth_tree_xml.get_widget("AuthWindow")
	self.authEntry = auth_tree_xml.get_widget("PassEntry")

	self.auth_window.hide_all()
	return


#if __name__ == '__main__':
#       auth_win = Auth_Win()
#       auth_win.auth_window.show_all()
#       gtk.main()
#       sys.exit(0) 
