#!/usr/bin/env python
## vim: tabstop=4:softtabstop=4:shiftwidth=4:noexpandtab 
#
#  Copyright (c) 2014 Dell, Inc.
#  by Praveen K Paladugu <praveen_paladugu@dell.com>
#  Licensed under the GNU General Public license, version 2 or higher.
#

import os, sys

try:
    import pygtk
    pygtk.require('2.0')
except:
    print "Required version of PyGTK is not installed."
    sys.exit(1)


try:
    import gtk
except:
    print "Gtk is not installed."
    sys.exit(1)


import gettext
gettext.textdomain('dell_app_init')
_ = lambda x: gettext.ldgettext('dell_app_init',x)


class DialogBox:
	""" A global Dialog Box to display a message and get quick respones from the user"""

	# Global vars	
	msg_to_display = ""
	dialog_win = ""
	buttons_selected = None
	def __init__(self,parent,msg, buttons=None):
		self.msg_to_display = msg
		self.dialog_win = gtk.MessageDialog(parent, gtk.DIALOG_DESTROY_WITH_PARENT | gtk.DIALOG_MODAL,
						gtk.MESSAGE_INFO, message_format = self.msg_to_display)
		if not buttons == None:
			self.buttons_selected = buttons

		return 

		
	def display(self):

		self.dialog_win.set_type_hint(gtk.gdk.WINDOW_TYPE_HINT_DIALOG)
		if self.buttons_selected == None:
			self.dialog_win.add_button(_("Yes"), gtk.RESPONSE_YES)
			self.dialog_win.add_button(_("No"), gtk.RESPONSE_NO)
			self.dialog_win.set_default_response(gtk.RESPONSE_NO)

		else :
			if self.buttons_selected == gtk.BUTTONS_OK:
				self.dialog_win.add_button(_("OK"), gtk.RESPONSE_OK)
				self.dialog_win.set_default_response(gtk.RESPONSE_CANCEL)

			if self.buttons_selected == gtk.BUTTONS_OK_CANCEL:
				self.dialog_win.add_button(_("OK"), gtk.RESPONSE_OK)
				self.dialog_win.add_button(_("CANCEL"), gtk.RESPONSE_CANCEL)
				self.dialog_win.set_default_response(gtk.RESPONSE_CANCEL)
			

		self.dialog_win.grab_focus()
		rc = self.dialog_win.run()
		self.dialog_win.destroy()
	
		return rc
	
