#!/usr/bin/env python
#
#  Copyright (c) 2014 Dell, Inc.
#  by Praveen K Paladugu <praveen_paladugu@dell.com>
#  Licensed under the GNU General Public license, version 2 or higher.
#

import sys
import logging
import subprocess
#import App_Conf_Parser
import DialogBox
import gettext
import shlex

gettext.textdomain('dell_app_init')
_ = lambda x: gettext.ldgettext("dell_app_init", x)

## X server should be up by now. So, the following import should be fine
try:
    import gtk
    import gtk.glade
except:
    print "Gtk/Glade is not installed."
    sys.exit(1)

gtk.glade.bindtextdomain('dell_app_init','/usr/share/locale')
gtk.glade.textdomain('dell_app_init')


class Password_Win:
    
    passWindow = 0
    passEntry1 = 0
    passEntry2 = 0
    currEntry = 0
    matchLabel = 0

    def on_Close_clicked (self,widget):
	
	not_matching_str = _("The new passwords don't match. Please update the entries and try again.")	
	
	entry1 = self.passEntry1.get_text()
	entry2 = self.passEntry2.get_text()
	curr_pass = self.currEntry.get_text()
	
	if (entry1 == entry2) and (entry1 != "") :
		# if password length is less than 8, show password strength failure message
		if len(entry1) < 8:
			msg = self.parser.get_conf_val("passwd", "password_strenght_req")
			db = DialogBox.DialogBox(self.passWindow, msg, buttons=gtk.BUTTONS_OK)
			db.dialog_win.set_default_response(gtk.RESPONSE_OK)
			rc = db.display()
			self.passWindow.show_all()
			return

		# if the passwords in the entries match, update the passwd now
		#import libuser
		#user_admin = libuser.ADMIN()
		#admin_entry = user_admin.lookupUserByName("root")
		#user_admin.setpassUser(admin_entry,entry1,0)
		self.run_post_script()
		return

	elif entry1 == entry2 and entry1 == "":
	    # If both the entries are empty, don't update and return
	    no_update = _("The password was not updated successfully.")
	    db = DialogBox.DialogBox(self.passWindow,no_update,buttons=gtk.BUTTONS_OK)
	    rc = db.display()
	    if rc == gtk.RESPONSE_OK:
		self.passWindow.hide_all()
		gtk.main_quit()
	
	else:
	    ## If the passwords in the entries don't match
	    db = DialogBox.DialogBox(self.passWindow,not_matching_str,buttons=gtk.BUTTONS_OK)
	    rc = db.display()
	    self.passWindow.show_all()	
	    return	
	        
	    

    
	self.passWindow.hide_all()
	gtk.main_quit()
	return

    def on_Password_Window_destroy (self, widget):
	self.passWindow.hide_all()
	gtk.main_quit()


#    def on_Pass_entry2_focus_out_event (self,widget,event):
#	print "Focus Out for Entry2"
#	print "Text in Entry2 =",self.passEntry2.get_text()

#	entry1 = self.passEntry1.get_text()
#	entry2 = self.passEntry2.get_text() 
#	if entry1 == entry2:
#	    self.matchLabel.set_text("Passwords match")
#	else: 
#	    self.matchLabel.set_text("Passwords Don't match")
    def on_Pass_entry_changed (self,widget):

	entry1 = self.passEntry1.get_text()
	entry2 = self.passEntry2.get_text()

	if widget == self.passEntry1  or widget == self.passEntry2:
		if entry1 == entry2 and entry1 != "":
			self.matchLabel.set_text("Passwords match")
			if  not self.currEntry.get_text() == "":
				self.cp_button.set_sensitive(True)

		elif entry1 == entry2 == "":
			self.matchLabel.set_text("")

        	else:
            		self.matchLabel.set_text("Passwords Don't match")
			self.cp_button.set_sensitive(False)

	if widget == self.currEntry:
		if entry1 == entry2 and entry1 != "" and self.currEntry.get_text() != "":
			self.cp_button.set_sensitive(True)

	if self.currEntry.get_text() == "" or entry1 == "" or entry2 == "":
		self.cp_button.set_sensitive(False)



#    def on_Pass_entry1_focus_out_event (self,widget,event):
#	print "Focus Out for Entry1"
#	print "Text in Entry1 =",self.passEntry1.get_text()

#	entry1 = self.passEntry1.get_text()
#	entry2 = self.passEntry2.get_text() 
#	if entry1 == entry2:
#	    self.matchLabel.set_text("Passwords match")
#	else: 
#	    self.matchLabel.set_text("Passwords Don't match")
	


    def display (self):
	    self.passWindow.show_all()
	    gtk.main_quit()
	    return	    


    def __init__(self,parser=""):

	if not parser == "":
	    self.parser = parser
	
	self.logger = logging.getLogger("startup_app.Password_Window")
	pass_window_glade_path =  "/usr/share/dell_app_init/Password_Window.glade"
	self.logger.debug (_("Glade file of Password Window = %s"), pass_window_glade_path )

	## load the Glade file
	passwindow_tree_xml = gtk.glade.XML(pass_window_glade_path,"Password_Window")

	#Connect the signal handlers
        passwindow_tree_xml.signal_autoconnect(self)
        self.passWindow = passwindow_tree_xml.get_widget("Password_Window")
        self.passEntry1 = passwindow_tree_xml.get_widget("Pass_entry1")
	self.currEntry = passwindow_tree_xml.get_widget("Curr Password")
	self.passEntry1.grab_focus()
        self.passEntry2 = passwindow_tree_xml.get_widget("Pass_entry2")
	self.matchLabel = passwindow_tree_xml.get_widget("pass_match")
	self.matchLabel.set_text("")
        self.cp_button = passwindow_tree_xml.get_widget("Change Password")
        self.cp_button1 = passwindow_tree_xml.get_widget("Cancel")
        self.cp_button.set_sensitive(False)


	self.passWindow.hide_all()
	return

    def run_post_script(self):

	if self.parser.get_conf_val("passwd","post_passwd_script")== "":
	    msg = _("Password script is not configured. Password was not updated successfully.")
	    db = DialogBox.DialogBox(self.passWindow,msg,buttons=gtk.BUTTONS_OK)
	    rc = db.display()
            self.passWindow.hide_all()
            gtk.main_quit()
				
	    return

	else:
	    post_script = self.parser.get_conf_val("passwd","post_passwd_script")

	    cmd = shlex.split(post_script)
	    cmd.append (self.currEntry.get_text())
	    cmd.append (self.passEntry1.get_text())
	    
	    cmd_out = subprocess.Popen(cmd, stdout=subprocess.PIPE, stderr=subprocess.STDOUT, shell=False)
	    cmd_out.wait() # wait for the process to complete and set the return code.
	    self.logger.info ("Output from the Post Passwd set command = \n%s", cmd_out.communicate()[0])
	    if cmd_out.returncode == 0:
	    	msg = _("Password was updated successfully.")
		self.logger.info ("Password was updated successfully")
	    	db = DialogBox.DialogBox(self.passWindow,msg,buttons=gtk.BUTTONS_OK)
		db.dialog_win.set_default_response(gtk.RESPONSE_OK)
	    	rc = db.display()
            	self.passWindow.hide_all()
            	gtk.main_quit()

	    elif cmd_out.returncode == 1:
		msg = _("Entered current password is incorrect. Please try again.")
	    	db = DialogBox.DialogBox(self.passWindow,msg,buttons=gtk.BUTTONS_OK)
		db.dialog_win.set_default_response(gtk.RESPONSE_OK)
	    	rc = db.display()
		self.passWindow.show_all()

	    elif cmd_out.returncode == 2:
		msg = _("Current and the new passwords are matching. Password was not updated successfully")
	    	db = DialogBox.DialogBox(self.passWindow,msg,buttons=gtk.BUTTONS_OK)
		db.dialog_win.set_default_response(gtk.RESPONSE_OK)
	    	rc = db.display()
		self.passWindow.hide_all()
		gtk.main_quit()

	    elif cmd_out.returncode == 3:
			## Password doesn't confirm to the format requirements.
		msg = self.parser.get_conf_val("passwd","password_strenght_req")
	    	db = DialogBox.DialogBox(self.passWindow,msg,buttons=gtk.BUTTONS_OK)
		db.dialog_win.set_default_response(gtk.RESPONSE_OK)
	    	rc = db.display()
		self.passWindow.show_all()

	    else: 
		msg = _("Password update was not successful.")
		
		self.logger.info (msg)
	    	db = DialogBox.DialogBox(self.passWindow,msg,buttons=gtk.BUTTONS_OK)
		db.dialog_win.set_default_response(gtk.RESPONSE_OK)
	    	rc = db.display()
		self.passWindow.hide_all()
		gtk.main_quit()
		
		
	    return
   

#if __name__ == '__main__':

#	pass_win = Password_Win()
#	pass_win.passWindow.show_all()
#	gtk.main()
#	sys.exit(0) 
